/* Visualizacin de ventanas de ayuda contextual.		*/
/* (C) 30 de Julio de 1.996, Salvador Pozo Coronado.  */
/* Revision 14 de Agosto de 2.000, documentacin y    */
/* optimizacion, adaptar a cualquier tipo de pantalla */

#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <stdlib.h>
#include <ctype.h>

#define HISTORIA	50

/* Tipos: */
struct TipoMenu /* Opciones de menu: */
{
  char Tecla;		         /* Tecla que activa el menu */
  char Clave[13]; 			/* Item referenciado, donde saltara */
};

struct TipoLinea 				/* Lineas de texto, elemento de lista
						  			doblemente enlazada */
{
  char Texto[81]; 			/* Texto de linea */
  TipoLinea *Sig, *Ant; 	/* Enlaces */
};

/* Prototipos de funciones, ver detalles al final: */
int Busca(FILE *fe, char *cad);
int LeeTexto(char *Palabra);
int Visualizar(int n, int na, int r);

// Variables globales:
char *Fichero; 				/* Fichero de ayuda */
int Menus;   					/* Numero de menus en texto actual */
int NoLineas; 					/* Numero de lineas de la lista de lineas en
									memoria */
int LineasPorPagina; 		/* En cada ventana de ayuda */
int ColumnasPorPagina; 		/* En cada ventana de ayuda */
char Historia[HISTORIA][13]; /* Tabla para guardar las ultimas etiquetas vistas,
									HISTORIA como mximo */
int NoHistoria; 				/* Numero de la ultima linea usada de Historia  */
TipoMenu Menu[30]; 			/* Tabla para los menus en el texto actual */
TipoLinea *Primera; 			/* Primer elemento de la lista de lineas de texto de
									actual */
char *Pantalla; 				/* Tabla para almacenar la pantalla y restaurarla
									al salir */

/***************************************************/
/* Funcion principal 										*/
/* Llamada al programa: ayuda <fichero> <item>     */
/***************************************************/
int main(int argc, char **argv)
{
	TipoLinea *q; 				/* Puntero auxiliar para borrado de lista de
									memoria */
	int Salir = 0;				/* Cambia a 1 cuando se pulsa 'Fin' */
   int n;						/* Numero de la primera linea a visualizar */
   int na;                 /* Numero de la primera linea visualizada la
   								ultima vez */
   int r;                  /* Si 1: Borrar y mostrar toda la ventana,
   								   Si 0: no borrar, scroll y actualizar */
   int i, j;               /* Auxiliares para bucles */
	int c;						/* Lectura del teclado */
	int extended = 0;       /* Segundo caracter de entrada para una tecla
   								especial: funcion, cursores, etc */
	struct text_info info;  /* Estrucura para capturar estado y propiedades de
   								la pantalla */
   FILE *fp;					/* Fichero para verificacion de existencia */

   if(argc < 3) return 0;  /* Si no recibimos el nombre de fichero de ayuda y
   								el elemento de estrada, regresamos sin mas */

	/* Inicializacion de variables */
	Primera = NULL;			/* El texto esta vacio */
	NoHistoria = 0;         /* Ningun elemento en la lista de visitados */
   Fichero = argv[1];		/* Nombre de fichero es el primer argumento */
   fp=fopen(Fichero, "r");	/* Intentamos abrir el fichero */
   if(fp) fclose(fp);		/* Si hemos podido, lo cerramos */
   else return 0;				/* Fichero no existe, salimos */
	strcpy(Historia[NoHistoria], argv[2]);
   								/* Primer elemento visitado es el segundo argumento */

   gettextinfo(&info);	   /* Leer las caracteristicas de la pantalla */
   LineasPorPagina = info.screenheight-4;		/* Numero de lineas que caben */
   ColumnasPorPagina = info.screenwidth-4;   /* Numero de columnas que caben */
   _setcursortype(_NOCURSOR); /* Oculta cursor */

	LeeTexto(argv[2]);		/* Leemos el texto correspondiente al elemento */
	n = 0;						/* Mostrar desde el principio, primera linea (0) */
	na = 0;						/* Nunca se mostro, asumimos la primera linea */

   Pantalla = (char *)malloc(sizeof(char)*2*info.screenheight*info.screenwidth);
   								/* Reserva memoria para guardar la pantalla
									   Se necesitan dos bytes por cada caracter en
                              pantalla, uno el caracter y otro los atributos
                              de color */

	gettext(info.winleft, info.wintop, info.winright, info.winbottom, Pantalla);
									/* Almacena la pantalla actual */
	window(2, 2, info.winright-1, info.winbottom-1);
   								/* Define la ventana que har de borde */
	textcolor(WHITE);			/* Letras en blanco */
	textbackground(GREEN);	/* Fondo en verde */
	clrscr();					/* Borrar la ventana, actualiza color de fondo */
	gotoxy(4, info.winbottom-2); /* Cursor en la ultima linea de la ventana */
	cprintf("%s", "Usar cursores, AvPg, RePg o Inicio. Fin para salir. "
   	"F2 Anterior.");     /* Muestra ayuda de navegacin */

	window(3, 3, info.winright-2, info.winbottom-2);
   								/* Define la ventana que har de area de texto */
	textbackground(BLUE);	/* Fondo en azul */
	clrscr();					/* Actualiza el area de impresion */
	Visualizar(n, na, 1);	/* Visualiza el texto, desde la primera linea
   								r=1, actualiza todas las lineas */

	/* Bucle, Salir cambiara al pulsar 'Fin', abandonando la navegacion */
	while(!Salir)				/* Mientras no queramos salir */
	{
		c = getch();			/* Leer teclado */
		na = n;              /* na es la primera linea mostrada la ultima vez */
		r = 0;					/* No borrar la pantalla */
		if (!c)					/* Si se lee un 0, es que se trata de un codigo */
      {							/* extendido, teclas especiales */
			extended = getch();	/* Lee el caracter extendido */
			switch(extended)	/* Actuar en consecuencia */
			{
				case 'H': 		/* Linea arriba */
					if(n > 0) n--; /* Si se puede n pasa a ser la linea anterior */
					break;
				case 'P': 		/* Linea abajo */
					if(n < NoLineas - LineasPorPagina) n++;
               				/* Si se puede n pasa a ser la linea siguiente */
					break;
				case 'I': 	  	/* Pagina arriba */
					n -= (LineasPorPagina-1);
               				/* Cuando subimos una pagina mantenemos la primera
                           linea */
					if(n < 0)   /* Si nos hemos pasado, */
               	n = 0;	/* visualizamos desde el principio */
					break;
				case 'Q': 	 	/* Pagina abajo */
					if(NoLineas > LineasPorPagina-1)
               				/* Si se puede n avanzar de linea... */
					{
						n += LineasPorPagina-1;
               				/* Cuando subimos una pagina mantenemos la primera
                           linea */
						if(n > NoLineas - LineasPorPagina)
                  	n = NoLineas - LineasPorPagina;
								   /* Si nos hemos pasado, */
               				/* visualizamos las ultimas lineas */
					}
					break;
				case 'O': 		/* Fin */
					Salir = 1;  /* Permiso para salir */
					break;
				case 60:			/* F2 */
					if(NoHistoria > 0) /* Si hay historia almacenada */
					{
						LeeTexto(Historia[--NoHistoria]);
                  			/* Visualiza el ultimo elemento visitado, y
                           actualiza NoHistoria */
						n = 0;	/* Ver desde la primera linea */
						r = 1;	/* Actualizar toda la ventana */
					}
					break;
			}
		}
		else  					/* Si no es un codifo extendido, ser un men */
		{
			for(i = 0; i < Menus; i++)	/* Busca en la lista de menus almacenados */
				         		/* Si la tecla pulsada esta en la lista: */
				if(toupper(Menu[i].Tecla) == toupper(c))
				{
					if(NoHistoria == HISTORIA)
					{
        				/* Si la tabla de historia esta llena olvidamos el ms
                  	antiguo y hacemos sitio para uno */
						for(j = 1; j < HISTORIA; j++)
							strcpy(Historia[j-1], Historia[j]);
						NoHistoria--;
					}
					strcpy(Historia[++NoHistoria], Menu[i].Clave);
               				/* Guarda el elemento del menu en la historia*/
					LeeTexto(Menu[i].Clave);
               				/* Lee texto del elemento elegido */
					n = 0;		/* Ver desde la primera linea */
					r = 1;		/* Actualizar toda la ventana */
					break;      /* No sigue comprobando, esto elimina la posibilidad
               					de mal funcionamieno por inclusion de dos
                              menus con la misma letra, solo se atendera al
                              primero, el resto se ignoran */
				}
		}
		Visualizar(n, na, r);/* Actualizar la ventana */
	}

	/* Salir del programa, restablecer pantalla y memoria */
   /* Borrar lista de lineas de la memoria */
	q = Primera;				/* Apuntamos al primer elemento */
	while(q)						/* Mientras queden elementos */
	{
		Primera = q->Sig;		/* Actualizamos el puntero al primer elemento
      							que sera el siguiente al que borraremos */
		free(q);					/* Borramos */
		q = Primera;			/* Volvemos a apuntar al primer elemento */
	}
	/* Restaura la pantalla a su estado inicial */
	window(info.winleft, info.wintop, info.winright, info.winbottom);
   								/* Define la ventana como toda la pantalla */
	puttext(info.winleft, info.wintop, info.winright, info.winbottom, Pantalla);
   								/* Restaura con los valores almacenados */
   free(Pantalla);			/* Libera la memoria */
   gotoxy(info.curx, info.cury);
   								/* Restablece coordenadas del cursor */
   _setcursortype(_NORMALCURSOR);
   								/* Restablece cursor */
   return 1;					/* Valor de retorno, todo ha ido bien */
}

/*****************************************************/
/* int LeeTexto(char *palabra)							  */
/*---------------------------------------------------*/
// (C) 30 de Julio de 1.996, Salvador Pozo Coronado. */
/*---------------------------------------------------*/
/* Lee el texto asociado a la palabra, reconocible   */
/* porque empieza de este modo [<palabra>]	    	  */
/* tambien lee los menus que encuentre y actualiza   */
/* las variables Menus y NoLineas					     */
/* Valor de retorno: 0, no se usa                    */
/*****************************************************/
int LeeTexto(char *Palabra)
{
	FILE *fe;					/* Fichero de entrada */
	char a;						/* Caracter leido del fichero */
	int i;						/* Caracteres en la linea actual */
   int j;	               /* Auxiliares en bucles */
	TipoLinea *Actual;		/* Puntero para manejo de linea actual */

   /* Primer borrar lista de lineas de la memoria */
	Actual = Primera;
	while(Actual)
	{
		Primera = Actual->Sig;
		delete Actual;
		Actual = Primera;
	}

	Primera = new TipoLinea;/* Crea una nueva lista de un solo elemento */
	Primera->Sig = NULL;		/* No hay siguiente */
	Primera->Ant = NULL;    /* Ni anterior */
	Actual = Primera;       /* La linea actual es la primera */
	i = 0;						/* Caracteres en la linea actual */
	NoLineas = 1;				/* Y solo tenemos una linea, por ahora */

	fe = fopen(Fichero, "r");	/* Abre el fichero en modo de lectura */
	Busca(fe, Palabra);     /* Y busca la posicion de la <palabra> dentro de el*/
	if(feof(fe))				/* Si se detecto fin de fichero es que no se
   								encontro la <palabra> */
		strcpy(Actual->Texto, "No encontrado.");
      							/*  y el texto pasa a ser "No encontrado" */
  	else							/* Si se encontro */
	{
		Menus = 0;				/* Comenzamos una nueva tabla de menus */
		while((a = getc(fe)) != '[' && !feof(fe))
      							/* Leer hasta la siguiente clave o hasta
                           fin de fichero */
		{
			switch (a)			/* Dependiendo del caracter leido */
			{
           case '\\': 		/* Tomar el siguiente caracter literalmente
           						toma caracteres con significado especial como
                           literales: [, ], {, }, \ y & */
				 a = getc(fe); /* El caracter que sigue a '\' se toma literalmente
             					y el '\' se ignora */
				 Actual->Texto[i++] = a; /* Almacenamos el caracter leido */
             break;
			  case '&':			/* Caracter que indica presencia de un menu */
				 Actual->Texto[i++] = '\255';
             					/* El caracter 255 indicar al que el siguiente
                           caracter se muestre en rojo */
				 a = getc(fe);	/* El siguiente caractes despus de '&' es la
             					tecla que activa el menu */
				 Actual->Texto[i++] = a;
             					/* Que adems se visualizar en rojo */
				 Menu[Menus].Tecla = a;
             					/* Y se guarda en la tabla de menus */
				 getc(fe);   	/* Se ignora el siguiente caracter, que se
             					supone que es '{', aunque no se verifica */
				 j = 0;			/* Contador para la longitud de la clave */
				 while((a = getc(fe)) != '}')
             					/* Leer caracteres hasta el '}' */
					 Menu[Menus].Clave[j++] = a;
                				/* Y guardarlos en el campo Clave */
				 Menu[Menus].Clave[j] = 0;
             					/* No olvidar el terminador */
				 Menus++;		/* ... Y tenemos otro menu en la tabla */
				 break;
           case '\r':		/* Ignorar los retornos de carro */
             break;
			  case '\n':		/* El retorno de linea implica un cambio de linea */
				 Actual->Texto[i] = 0;
             					/* Terminador de linea de texto */
				 Actual->Sig = new TipoLinea;
             					/* Creamos otra linea a continuacion de la ultima */
				 Actual->Sig->Ant = Actual;
             					/* Cuyo elemento anterior debe ser el actual */
				 Actual = Actual->Sig;
             					/* Actualizmos el puntero a Actual al ultimo */
				 Actual->Sig = NULL;
             					/* Y no hay siguiente. */
				 i = 0;			/* Volvemos a emprezar una linea */
				 NoLineas++;	/* Y tenemos una linea mas */
				 break;
			  default:			/* El resto de los caracteres se almacenan tal cual*/
				 Actual->Texto[i++] = a;
			}
			if(i >= ColumnasPorPagina-1)
         						/* Si sobrepasamos la capacidad de una linea */
			{
				 Actual->Texto[i] = 0;
             					/* Terminador de linea de texto */
				 Actual->Sig = new TipoLinea;
             					/* Creamos otra linea a continuacion de la ultima */
				 Actual->Sig->Ant = Actual;
             					/* Cuyo elemento anterior debe ser el actual */
				 Actual = Actual->Sig;
             					/* Actualizmos el puntero a Actual al ultimo */
				 Actual->Sig = NULL;
             					/* Y no hay siguiente. */
				 while(Actual->Ant->Texto[i] != ' ') i--;
									/* Buscamos el ultimo espacio de la linea larga */
				 Actual->Ant->Texto[i] = 0;
             					/* Cortamos la linea larga a la altura del ultimo
                           espacio, para no cortar palabras */
				 i++;          /* nos saltamos el espacio, que ahora es un 0 */
				 j = 0;
				 while(Actual->Ant->Texto[i])
					 Actual->Texto[j++] = Actual->Ant->Texto[i++];
                				/* Y copiamos el sobrante de la linea a la
                           ultima linea */
				 i = j;			/* Actualizamos la longitud de la ultima linea */
				 NoLineas++;	/* Y tenemos otra linea */
			}
		}
		Actual->Texto[i] = 0;/* Que la ultima linea leida no quede sin termianr */
	}
	fclose(fe);					/* Cerrar el fichero */

	return 0;					/* Retorna con 0 */
}

/*****************************************************/
/* int Visualizar(int n, int na, int r)				  */
/*---------------------------------------------------*/
// (C) 30 de Julio de 1.996, Salvador Pozo Coronado. */
/*---------------------------------------------------*/
/* Visualiza el texto asociado a la clave actual     */
/* desde la linea n, na era donde de empezo la ultima*/
/* vez, solo se usa si r = 1, para mostrar solo las  */
/* lineas que son nuevas en pantalla				     */
/* Si r = 1 se visualizan todas las lineas de la	  */
/* ventana, se es 0 solo las nuevas						  */
/* Valor de retorno: 0, no se usa                    */
/*****************************************************/
int Visualizar(int n, int na, int r)
{
	int i, j;					/* Auxiliares */
   int k;						/* Numero de lineas desplazadas */
   int l;						/* Coordenada de la linea a mostrar */
	TipoLinea *Actual;		/* Puntero a la linea actualmente visualizada */

	k = n - na;					/* Numero de lineas de nueva visualizacin
   								si es positivo sern por abajo, "scroll" arriba,
                           si es negativo por arriba, "scroll" abajo */
	if(r)							/*	Si hay que repintar todo */
	{
		k = LineasPorPagina;	/* k son todas las lineas */
		clrscr();				/* y borramos la ventana */
	}

	Actual = Primera;			/* Actual apunta a la primera linea */
	if(k > 0)					/* Desplazamiento hacia arriba k lineas */
	{
		movetext(3, 3+k, ColumnasPorPagina+2, LineasPorPagina+2, 3, 3);
      							/* Desplazamiento de las lineas que solo cambian
      							de posicion "scroll" */
		for(i = 0; i < n+LineasPorPagina-k ; i++)	Actual = Actual->Sig;
      							/* Hacemos que Actual apunte a la primera linea
                           nueva a visualizar */
		l = LineasPorPagina-k+1;
      							/* Coordenada de la primera linea a mostrar */
	}
	else							/* Desplazamiento hacia abajo -k lineas */
	{
		movetext(3, 3, ColumnasPorPagina+2, LineasPorPagina+2+k, 3, 3-k);
      							/* Desplazamiento de las lineas que solo cambian
      							de posicion "scroll" */
		for(i = 0; i < n ; i++) Actual = Actual->Sig;
      							/* Hacemos que Actual apunte a la primera linea
                           nueva a visualizar */
		k = -k;					/* Cambio de signo, k es un numero de lineas */
		l = 1;					/* Coordenada de la primera linea a mostrar */
	}

   /* Mostrar en pantalla las lineas necesarias o hasta que se acaben,
   (lo cual nunca deberia pasar) */
	for (j = 0; j < k && Actual; j++)
	{
		gotoxy(1, j+l);		/* Coordenadas de pantalla */
		clreol();				/* Borra la linea */
		gotoxy(1, j+l);		/* Actualiza coordenadas de pantalla */
		i = 0;               /* Recorrer el texto */
		while(Actual->Texto[i])	/* Hasta fin de linea */
			switch (Actual->Texto[i])	/* Comprobar si hay menus */
			{
				case '\255':	/* Indica presencia de menu */
				 i++;				/* Ignoramos el caracter '\255' */
				 textbackground(RED);
             					/* Fondo rojo */
				 cprintf("%c", Actual->Texto[i++]);
             					/* Visualizamos caracter correspondiente a menu */
				 textbackground(BLUE);
             					/* Restablecemos el fondo azul */
				 break;
				default:			/* El resto de los caracteres de muestran tal cual */
				 cprintf("%c", Actual->Texto[i++]);
			}
		Actual = Actual->Sig;/*Siguiente linea */
	}

	return 0;					/* Retorna con 0 */
}

/*****************************************************/
/* int Busca(FILE *fe, char *cad)				  		  */
/*---------------------------------------------------*/
// (C) 30 de Julio de 1.996, Salvador Pozo Coronado. */
/*---------------------------------------------------*/
/* Busca la cadena <cad> en el fichero de ayuda      */
/* siempre y cuando se trate de una etiqueta         */
/* fe es el fichero, previamente abierto en modo     */
/* de lectura                        				     */
/* La siguiente caracter a leer del fichero sera     */
/* El primero del texto asociado a la cadena "cad"   */
/* Valor de retorno: 1 si se encontro, 0 si no       */
/*****************************************************/
int Busca(FILE *fe, char *cad)
{
  int retval = 0;				/* Valor de retorno, por defecto 0
  									cambiara a 1 cuando se encuentre la palabra */
  int i;							/* Caracteres coincidentes */
  char palabra[128];			/* Palabra completa a buscar: "[<cad>]" */
  char a;						/* Caracter leido del fichero */

  strcpy(palabra, "[");		/* Conversin de cad en una clave */
  strcat(palabra, cad);    /* del tipo "[<cad>]" */
  strcat(palabra, "]");

  i = 0;							/* caracteres coincidentes por ahora en la
  									misma secuencia entre el fichero y la palabra */
  while(!feof(fe) && !retval) /* seguir buscando hasta fin de fichero o */
  {								/* Hasta encontrar la palabra */
	  a = getc(fe);			/* Lee un caracter */
	  if(a == palabra[i]) i++; /* Si coincide con el siguiente aumentar i */
     else i = 0;				/* Si no, hay que volver a empezar */
	  if(i == strlen(palabra)) retval = 1;
     								/* Si los caracteres que coinciden son todos,
                           es que hemos encontrado la palabra */
  }
  /* La posicion de lectura en el fichero queda actualizada */
  return retval;				/* Valor de retorno */
}

